﻿using Microsoft.AspNetCore;
using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Hosting;
using NLog.Web;
using System;
using System.Diagnostics;
using System.IO;
using System.Linq;
using Topshelf;

namespace ConsoleApp2
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("自动备份云服务器数据库!");

            var isService = !(Debugger.IsAttached || args.Contains("--console"));

            //var builder = CreateWebHostBuilder(args.Where(arg => arg != "--console").ToArray());
            var Configuration = new ConfigurationBuilder()
                     .SetBasePath(Directory.GetCurrentDirectory())
                     .AddJsonFile("Conf/appsettings.json", optional: true, reloadOnChange: true)
                     .Build();
            if (isService)
            {

                HostFactory.Run(x =>
                {
                    x.Service<ServiceCenter>();
                    x.RunAsLocalSystem();
                    x.SetDescription("自动备份");
                    x.SetDisplayName("自动备份");
                    x.SetServiceName("自动备份");

                    x.EnablePauseAndContinue();
                });
            }
            else
            {
                //ILoggerRepository repository = LogManager.CreateRepository("NETCoreRepository");
                //XmlConfigurator.Configure(repository, new FileInfo(Directory.GetCurrentDirectory() + "\\Conf\\log4net.config"));

                CreateHostBuilder(args).Build().Run();
            }
        }

        public static IWebHostBuilder CreateHostBuilder(string[] args) =>
            WebHost.CreateDefaultBuilder(args)
                .UseStartup<Startup>();
            //.UseNLog();
    }
}
/*
             WebHost.CreateDefaultBuilder(args)
                .UseConfiguration(new ConfigurationBuilder()
                    .SetBasePath(AppContext.BaseDirectory)
                    .AddJsonFile("appsettings.json", optional: true)
                    .Build())
                .UseStartup<Startup>()
            .ConfigureLogging(logging =>
            {
                logging.ClearProviders();
                logging.SetMinimumLevel(Microsoft.Extensions.Logging.LogLevel.Trace);
            }) 
            .UseNLog();
     */
